<?php

namespace Andy\WeeklyDigest\Pub\Controller;

use XF\Pub\Controller\AbstractController;

class WeeklyDigest extends AbstractController
{
    public function actionIndex()
    {
		//########################################
		// Display a page for the member to
		// subscribe or unsubscribe to the
		// Weekly Digest.
		//########################################
		
		// get visitor
		$visitor = \XF::visitor();
		
		// get userId
		$userId = $visitor['user_id'];
		
        // check condition
		if ($userId == 0)
		{
			return $this->noPermission();
		}

        // check condition
		if ($userId > 0)
		{
			// declare variable
			$subscribed = '';

            // get result
            $finder = \XF::finder('XF:User');
            $result = $finder
                ->where('user_id', $userId)
                ->fetchOne();

            // get andy_weekly_digest_opt_out
            $andy_weekly_digest_opt_out = $result['andy_weekly_digest_opt_out'];

			// get viewParams
			$viewParams = [
				'andy_weekly_digest_opt_out' => $andy_weekly_digest_opt_out
			];
			
			// send to template
			return $this->view('Andy\WeeklyDigest:Index', 'andy_weeklydigest', $viewParams);
		}
	}
	
	public function actionSave()
	{
		//########################################
		// Save members choice.
		//########################################
				
		// get visitor
		$visitor = \XF::visitor();
		
		// get userId
		$userId = $visitor['user_id'];
		
		if ($userId == 0)
		{
			return $this->actionRegistrationRequired();	
		}	
		
		if ($userId > 0)
		{
			// get members choice
			$subscribe = $this->filter('subscribe', 'uint');			

			if ($subscribe == 0)
			{
                // get results
                $finder = \XF::finder('XF:User');
                $results = $finder
                    ->where('user_id', $userId)
                    ->fetch();

                // foreach condition
                foreach ($results as $result)
                {
                    $data = [
                        'andy_weekly_digest_opt_out' => 0
                    ];

                    $result->fastUpdate($data);
                }
			}
			
			if ($subscribe == 1)
			{
                // get results
                $finder = \XF::finder('XF:User');
                $results = $finder
                    ->where('user_id', $userId)
                    ->fetch();

                // foreach condition
                foreach ($results as $result)
                {
                    $data = [
                        'andy_weekly_digest_opt_out' => 1
                    ];

                    $result->fastUpdate($data);
                }	
			}
		}

		// return redirect
		return $this->redirect(
			$this->getDynamicRedirect($this->buildLink('weeklydigest/'))
		);
	}
}