<?php

namespace Andy\WeeklyDigest\XF\Cron;

class WeeklyDigest
{
	public static function runWeeklyDigest()
	{	
		// calculate dateline
		$dateline = time() - (86400 * 7);
		
		//########################################
		// get options
		//########################################
		
		// get options
		$options = \XF::options();	
		
		// get options from Admin CP -> Options -> Weekly digest -> Emoji
		$emoji = $options->weeklyDigestEmoji;

		// get options from Admin CP -> Options -> Weekly digest -> Exclude forums
		$excludeForums = $options->weeklyDigestExcludeForums;
		
		// get options from Admin CP -> Options -> Weekly digest -> Last activity days
		$lastActivityDays = $options->weeklyDigestLastActivityDays;
		
		// get options from Admin CP -> Options -> Weekly digest -> Limit
		$limit = $options->weeklyDigestLimit;
		
		// get options from Admin CP -> Options -> Weekly digest -> Sort Forum Titles
		$sortForumTitles = $options->weeklyDigestSortForumTitles;
		
		// get options from Admin CP -> Options -> Weekly digest -> Test username
		$testUsername = $options->weeklyDigestTestUsername;
		
		//########################################
		// get conditions
		//########################################
		
		$conditions[] = ['node_id', '<>', 0];
	
		foreach($excludeForums as $value)
		{
			$conditions[] = ['node_id', '<>', $value];
		}
		
		//########################################
		// get threads
		//########################################				

		if (!$sortForumTitles)
		{
			$finder = \XF::finder('XF:Thread');
				$threads = $finder
				->with('Forum')
				->with('Forum.Node')
				->where('post_date', '>', $dateline)
				->where('discussion_state', '=', 'visible')
				->where('discussion_type', '<>', 'redirect')
				->where($conditions)
				->order('view_count', 'DESC')
				->limit($limit)
				->fetch();	
		}
		
		if ($sortForumTitles)
		{
			$finder = \XF::finder('XF:Thread');
				$threads = $finder
				->with('Forum')
				->with('Forum.Node')
				->where('post_date', '>', $dateline)
				->where('discussion_state', '=', 'visible')
				->where('discussion_type', '<>', 'redirect')
				->where($conditions)
				->order('Forum.Node.title', 'ASC')
				->order('view_count', 'DESC')
				->limit($limit)
				->fetch();	
		}

		// continue only if we have posts
		if (count($threads) > 0)
		{
			//########################################
			// get members - testUsername
			//########################################	
            
            // get result
            $finder = \XF::finder('XF:User');
            $result = $finder
                ->where('username', $testUsername)
                ->fetchOne();

            // check condition
            if (!empty($result['user_id']))
            {
                $userId = $result['user_id'];
                
                $finder = \XF::finder('XF:User');
                $members = $finder
                    ->where('user_id', $userId)
                    ->fetch();
            }
			
			//########################################
			// get members
			//########################################					

            // check condition
			if (empty($userId))
			{
				// calculate dateline
				$dateline = time() - (86400 * $lastActivityDays);
                
                // get members
                $finder = \XF::finder('XF:User');
                $members = $finder
                    ->where('last_activity', '>', $dateline)
                    ->where('user_state', 'valid')
                    ->where('is_banned', 0)
                    ->where('andy_weekly_digest_opt_out', 0)
                    ->where('Option.receive_admin_email', 1)
                    ->where('Option.is_discouraged', 0)
                    ->fetch();
			}

			//########################################
			// send emails
			//########################################
			
			// prepare variable
			eval("\$str = \"$emoji\";");
			
			// check condition
			if ($str != '')
			{
				$str = $str . ' ';
			}

			// foreach member
			foreach ($members as $member)
			{				
				$mail = \XF::app()->mailer()->newMail();
				
				$user = \XF::app()->find('XF:User', $member['user_id']);

				$mail->setToUser($user);

				$mail->setTemplate('andy_weeklydigest', [
					'threads' => $threads,
					'emoji' => $str
				]);
				
				$mail->queue();
			}
		}	
	}
}